{ Copyright (C) 09/09/2004 00:00, Luis R. Hilario B. <info@luisdigital.com>

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Library General Public License as published by
  the Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}

unit principal;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, LResources, Buttons,
  ExtCtrls, ComCtrls,
  klintonstrconst, menu;

type
  TForm1 = class(TForm)
    Button1: TBUTTON;
    Button2: TBUTTON;
    procedure Button1CLICK(Sender: TObject);
    procedure Button2CLICK(Sender: TObject);
    procedure Form1CLOSE(Sender: TObject; var Action: TCloseAction);
    procedure Form1CREATE(Sender: TObject);
    procedure Form1PAINT(Sender: TObject);
    procedure Form1SHOW(Sender: TObject);
  private
    { private declarations }
      FPicture: TPixmap;
  public
    { public declarations }
  end;

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.Button2CLICK(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button1CLICK(Sender: TObject);
begin
  Form2.Show; // Si escribo "ShowModal" entonces no aparecen los Hints
end;

procedure TForm1.Form1CLOSE(Sender: TObject; var Action: TCloseAction);
begin
  Form2.FLogo.Free;
  FPicture.Free;
end;

procedure TForm1.Form1CREATE(Sender: TObject);
begin
    FPicture := TPixmap.Create;
    FPicture.LoadFromLazarusResource('logo');
end;

procedure TForm1.Form1PAINT(Sender: TObject);
var
  LeftPosition, TopPosition: Integer;
  
begin
//Color solamente funciona en la primera "Forma" (ventana).
  
  LeftPosition := (Form1.Width div 2) - (FPicture.Width div 2);
  TopPosition := (Form1.Height div 2) - FPicture.Height;

  Button1.Top := Form1.Height - (Button1.Height * 4);
  Button1.Left := (Form1.Width div 2) - (FPicture.Width div 2);
  Button2.Top := Form1.Height - (Button1.Height * 4);
  Button2.Left := (FPicture.Width - Button2.Width) + (Button1.Left);

  Canvas.Copyrect(Bounds(LeftPosition, TopPosition,
                  FPicture.Width, FPicture.Height),
                  FPicture.Canvas,
                  Rect(0, 0, FPicture.Width, FPicture.Height));

  Canvas.font.color := clBtnFace;
  Canvas.TextOut(LeftPosition, TopPosition + FPicture.Height + 1, rsVersion);
  Canvas.TextOut(LeftPosition, TopPosition + FPicture.Height + 23, rsSerie);
  Canvas.TextOut(LeftPosition, TopPosition + FPicture.Height + 38, rsDerechos);

// Para desabilitar cuando Menu esta presente, pero deberia de ir en otra parte
// if Form2.Showing = true then Enabled := False else Enabled := True;
end;

procedure TForm1.Form1SHOW(Sender: TObject);
begin
  //WindowState := wsMaximized; No funciona...
  Width := Screen.Width;
  Height := Screen.Height;
 // Position := poScreenCenter; No funciona...
  Top := 0;
  Left := -4;
end;

initialization
  { $I principal.lrs}
  {$I logo.lrs}
  {$I mainicon.lrs}

end.

