{ Copyright (C) 09/09/2004 00:00, Luis R. Hilario B. <info@luisdigital.com>

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Library General Public License as published by
  the Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}

unit util;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Graphics, Dialogs;

function SystemBrowser(const Opt: String): String;
procedure AyudaHTML(const ConTexto: string);
function CargarRecImag(const Recurso: string): TPixmap;
function CargarArcImag(const NombreArchivo: string): TPixmap;
procedure MSGInfo(MSG: String);
procedure MSGError(MSG: String);
function MSGConfirmationYN(MSG: String): Integer;
function StrNumStr(Text: String; Int,Dec: Integer):String;
function StrReal(Text: String):Real;
function NumStr(N: Real): String;
function NumStr(N: Integer): String;


implementation

uses
 TXTDB, Process, klintonstrconst;

function SystemBrowser(const Opt: String): String;
var
  Browser,
  FullPath,
  Name,
  Para: String;

begin
  FullPath := '';
  Name := '';
  Para := '';
  Browser := GetEnvironmentVariable('BROWSER');
  Name := Copy(Browser, 1, Pos(' ', Browser +' ')-1);
  if Length(Name) <> Length(Browser) then
   Para := Copy(Browser, Pos(' ', Browser)+1, Length(Browser));

  FullPath := FileSearch(Name, GetEnvironmentVariable('PATH'));
  if Opt = 'FullPath' then Result := FullPath else
   if Opt = 'Name' then Result := Name else
    if Opt = 'Para' then Result := Para else
     Result := '';
end;

procedure AyudaHTML(const ConTexto: string);
var
  Process1: TProcess;

begin
  Process1 := TProcess.create(nil);
  With TTXTDB.create(ArchivoTXTDBConf) do
  begin
   ReadTXTDB;
   Process1.CommandLine := RecordData[fnNAVEGADOR] + ' '+
                           RecordData[fnPARAMETROS] + ' '+
                           GetCurrentDir+ '/'+ArchivoAyuda;
   Free;
  end;
   if ConTexto <> '' then Process1.CommandLine := Process1.CommandLine +
                                                  ConTexto;
   //Process1.ApplicationName
   Process1.Execute;
   Process1.Free;
end;

function CargarRecImag(const Recurso: string): TPixmap;
begin
  Result := TPixmap.Create;
  Result.LoadFromLazarusResource(Recurso);
end;

function CargarArcImag(const NombreArchivo: string): TPixmap;
var
  S: TFileStream;
  
begin
  S := TFileStream.Create(NombreArchivo, fmOpenRead);
  try
    Result := TPixmap.Create;
//    Result.TransparentColor := $90A050;
    Result.LoadFromStream(S);
  finally
    S.Free;
  end;
end;

procedure MSGInfo(MSG: String);
begin
  MessageDlg(rsInformacion, MSG, mtInformation, [mbOK], 0);
end;

procedure MSGError(MSG: String);
begin
  MessageDlg(MSG, mtError, [mbOK], 0);
end;

function MSGConfirmationYN(MSG: String): Integer;
begin
  Result := MessageDlg(rsConfirmacion, MSG,
            mtConfirmation, [mbYes, mbNo], 0)
end;

function StrNumStr(Text: String; Int,Dec: Integer):String;
var
  S: String;
  R: Real;
  Code: Integer;

begin
 Val(Text, R, Code);
  if Code <> 0 then R := 0;

  Str(R:Int:Dec, S);
  Result := S;
end;

function StrReal(Text: String):Real;
var
  R: Real;
  Code: Integer;

begin
 Val(Text, R, Code);
  if Code <> 0 then R := 0;

  Result := R;
end;

function NumStr(N: Real): String;
begin
  Str(N, Result)
end;

function NumStr(N: Integer): String;
begin
  Str(N, Result)
end;

initialization
  SetCurrentDir(ExtractFilePath(ParamStr(0)));
  DateSeparator := '-';

end.

