{ Copyright (C) 09/09/2004 00:00, Luis R. Hilario B. <info@luisdigital.com>

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Library General Public License as published by
  the Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}

unit clientes;

{$IFDEF FPC}
 {$mode objfpc}
{$ENDIF}
{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs,
  {$IFDEF FPC}LResources,{$ENDIF} ComCtrls,
  Buttons, ExtCtrls,
  util, adicionar, klintonstrconst, TXTDB, StdCtrls;

type
  TForm4 = class(TForm)
    BitbtnCrear: TBITBTN;
    BitbtnMod: TBITBTN;
    BitbtnEli: TBITBTN;
    Bitbtn4: TBITBTN;
    BitbtnCerrar: TBITBTN;
    Listview1: TLISTVIEW;
    procedure BitbtnCrearCLICK(Sender: TObject);
    procedure BitbtnEliCLICK(Sender: TObject);
    procedure BitbtnModCLICK(Sender: TObject);
    procedure Form4CREATE(Sender: TObject);
    procedure Form4SHOW(Sender: TObject);
    procedure Bitbtn4Click(Sender: TObject);
  private
    { private declarations }
    procedure UpdateListView1;
  public
    { public declarations }
  end; 

var
  Form4: TForm4;
  TXTDBClientes: TTXTDB;

implementation

{ TForm4 }

procedure TForm4.Form4CREATE(Sender: TObject);
begin
  BitbtnCrear.Caption := rsANuevo;
  BitbtnMod.Caption := rsAModificar;
  BitbtnEli.Caption := rsAEliminar;
  Bitbtn4.Caption := rsAAyuda;
  BitbtnCerrar.Caption := rsACerrar;
end;

procedure TForm4.Form4SHOW(Sender: TObject);
begin
  UpdateListView1;
end;

procedure TForm4.UpdateListView1;
var
  Index: Integer;
  Iteme: TListItem;

begin
  TXTDBClientes := TTXTDB.create(ArchivoTXTDBClientes);
  TXTDBClientes.ReadTXTDB;
  Listview1.Items.Clear;
  for Index := 1 to TXTDBClientes.RecordCount do
  begin
    Iteme := Listview1.Items.Add;
    TXTDBClientes.RecordIndex := Index;
    Iteme.Caption := TXTDBClientes.RecordData[fnCODIGO];
    Iteme.SubItems.Add(TXTDBClientes.RecordData[fnNOMBRE]);
    Iteme.SubItems.Add(TXTDBClientes.RecordData[fnCONTACTO]);
    Iteme.SubItems.Add(TXTDBClientes.RecordData[fnTEL]);
    Iteme.SubItems.Add(TXTDBClientes.RecordData[fnCATEGORIA]);
  end;
  TXTDBClientes.Free;
end;

procedure TForm4.BitbtnCrearCLICK(Sender: TObject);
begin
  With Form5 do
  begin
    EditCodigo.Enabled := True;
    EditCodigo.Text := cCODE;
    EditNombre.Text := '';
    Combobox1.ItemIndex := 0;
    Combobox2.ItemIndex := 0;
    EditDir1.Text := '';
    EditDir2.Text := '';
    EditCiudad.Text := '';
    EditEstado.Text := '';
    EditZIP.Text := '';
    EditPais.Text := '';
    EditContacto.Text := '';
    EditTel.Text := '';
    EditFax.Text := '';
    EditRegT.Text := '';
    EditEMail.Text := '';
    EditNotas1.Text := '';
    EditNotas2.Text := '';
    EditNotas3.Text := '';
    TextoFecha.Caption := DateTimeToStr(Date);
    Caption := rsNuevo;
  end;
  Hide;
  TXTDBClientes := TTXTDB.create(ArchivoTXTDBClientes);
  TXTDBClientes.ReadTXTDB;

  Repeat
    if Form5.Showmodal = mrOK then ModalResult := mrOK
    else ModalResult := mrNone;

    if TXTDBClientes.DataExist(fnCODIGO, Form5.EditCodigo.Text)
       And (ModalResult = mrOK) then MSGInfo('El Cdigo ya existe.');

  Until Not TXTDBClientes.DataExist(fnCODIGO, Form5.EditCodigo.Text)
        Or (ModalResult = mrNone);

  if ModalResult = mrOK then
  begin
    TXTDBClientes.RecordAdd;
  With Form5 do
    begin
      TXTDBClientes.RecordData[fnCODIGO] := EditCodigo.Text;
      TXTDBClientes.RecordData[fnNOMBRE] := EditNombre.Text;
      TXTDBClientes.RecordData[fnCATEGORIA] := Combobox1.Text;
      TXTDBClientes.RecordData[fnSUBC] := Combobox2.Text;
      TXTDBClientes.RecordData[fnDIR1] := EditDir1.Text;
      TXTDBClientes.RecordData[fnDIR2] := EditDir2.Text;
      TXTDBClientes.RecordData[fnCIUDAD] := EditCiudad.Text;
      TXTDBClientes.RecordData[fnESTADO] := EditEstado.Text;
      TXTDBClientes.RecordData[fnZIP] := EditZIP.Text;
      TXTDBClientes.RecordData[fnPAIS] := EditPais.Text;
      TXTDBClientes.RecordData[fnCONTACTO] := EditContacto.Text;
      TXTDBClientes.RecordData[fnTEL] := EditTel.Text;
      TXTDBClientes.RecordData[fnFAX] := EditFax.Text;
      TXTDBClientes.RecordData[fnRT] := EditRegT.Text;
      TXTDBClientes.RecordData[fnEMAIL] := EditEMail.Text;
      TXTDBClientes.RecordData[fnNOTA1] := EditNotas1.Text;
      TXTDBClientes.RecordData[fnNOTA2] := EditNotas2.Text;
      TXTDBClientes.RecordData[fnNOTA3] := EditNotas3.Text;
      TXTDBClientes.RecordData[fnFECHAC] := TextoFecha.Caption;
      TXTDBClientes.WriteTXTDB;
    end;
  end;
  TXTDBClientes.Free;
  ModalResult := mrNone;
  Show;
end;

procedure TForm4.BitbtnEliCLICK(Sender: TObject);
var
  RecordDeleted: Boolean;

begin
//  if ListView1.SelCount < 1 then SelCount parece que no existe.
  if ListView1.Selected = nil then MSGInfo(rsNoSelected)
  else
    if MSGConfirmationYN(rsDeleteReg) = mrYes then
    begin
      TXTDBClientes := TTXTDB.create(ArchivoTXTDBClientes);
      TXTDBClientes.ReadTXTDB;
      TXTDBClientes.RecordIndex := ListView1.Selected.Index +1;
      RecordDeleted := TXTDBClientes.RecordDelete;
      TXTDBClientes.Free;
      if RecordDeleted then UpdateListView1 else MSGError(rsNoDeleted);
    end;
end;

procedure TForm4.BitbtnModCLICK(Sender: TObject);
var
  Index: Integer;

begin
  if ListView1.Selected = nil then MSGInfo(rsNoSelected)
  else
    begin
      TXTDBClientes := TTXTDB.create(ArchivoTXTDBClientes);
      TXTDBClientes.ReadTXTDB;
      TXTDBClientes.RecordIndex := ListView1.Selected.Index +1;
      With Form5 do
      begin
        EditCodigo.Enabled := False;
        EditCodigo.Text := TXTDBClientes.RecordData[fnCODIGO];
        EditNombre.Text := TXTDBClientes.RecordData[fnNOMBRE];
        Index := -1;
        Repeat
          inc(Index);
        Until (Index = Combobox1.Items.Count -1) Or
          (Combobox1.Items[Index] = TXTDBClientes.RecordData[fnCATEGORIA]);
        Combobox1.ItemIndex := Index;

        Index := -1;
        Repeat
          inc(Index);
        Until (Index = Combobox2.Items.Count -1) Or
          (Combobox2.Items[Index] = TXTDBClientes.RecordData[fnSUBC]);
        Combobox2.ItemIndex := Index;
        EditDir1.Text := TXTDBClientes.RecordData[fnDIR1];
        EditDir2.Text := TXTDBClientes.RecordData[fnDIR2];
        EditCiudad.Text := TXTDBClientes.RecordData[fnCIUDAD];
        EditEstado.Text := TXTDBClientes.RecordData[fnESTADO];
        EditZIP.Text := TXTDBClientes.RecordData[fnZIP];
        EditPais.Text := TXTDBClientes.RecordData[fnPAIS];
        EditContacto.Text := TXTDBClientes.RecordData[fnCONTACTO];
        EditTel.Text := TXTDBClientes.RecordData[fnTEL];
        EditFax.Text := TXTDBClientes.RecordData[fnFAX];
        EditRegT.Text := TXTDBClientes.RecordData[fnRT];
        EditEMail.Text := TXTDBClientes.RecordData[fnEMAIL];
        EditNotas1.Text := TXTDBClientes.RecordData[fnNOTA1];
        EditNotas2.Text := TXTDBClientes.RecordData[fnNOTA2];
        EditNotas3.Text := TXTDBClientes.RecordData[fnNOTA3];
        TextoFecha.Caption := TXTDBClientes.RecordData[fnFECHAC];
        Caption := rsModificar;
      end;
      Hide;
      if Form5.Showmodal = mrOK then
      begin With Form5 do
        begin
          TXTDBClientes.RecordData[fnNOMBRE] := EditNombre.Text;
          TXTDBClientes.RecordData[fnCATEGORIA] := Combobox1.Text;
          TXTDBClientes.RecordData[fnSUBC] := Combobox2.Text;
          TXTDBClientes.RecordData[fnDIR1] := EditDir1.Text;
          TXTDBClientes.RecordData[fnDIR2] := EditDir2.Text;
          TXTDBClientes.RecordData[fnCIUDAD] := EditCiudad.Text;
          TXTDBClientes.RecordData[fnESTADO] := EditEstado.Text;
          TXTDBClientes.RecordData[fnZIP] := EditZIP.Text;
          TXTDBClientes.RecordData[fnPAIS] := EditPais.Text;
          TXTDBClientes.RecordData[fnCONTACTO] := EditContacto.Text;
          TXTDBClientes.RecordData[fnTEL] := EditTel.Text;
          TXTDBClientes.RecordData[fnFAX] := EditFax.Text;
          TXTDBClientes.RecordData[fnRT] := EditRegT.Text;
          TXTDBClientes.RecordData[fnEMAIL] := EditEMail.Text;
          TXTDBClientes.RecordData[fnNOTA1] := EditNotas1.Text;
          TXTDBClientes.RecordData[fnNOTA2] := EditNotas2.Text;
          TXTDBClientes.RecordData[fnNOTA3] := EditNotas3.Text;
          TXTDBClientes.WriteTXTDB;
        end;
      end;
      TXTDBClientes.Free;
      ModalResult := 0;
      Show;
    end;
end;

procedure TForm4.Bitbtn4Click(Sender: TObject);
begin
  AyudaHTML(Con_Opc);
end;

initialization
{$IFDEF FPC}
  {$I pics/botones.lrs}
  { $I clientes.lrs}
{$ELSE}
  {$R *.dfm}
{$ENDIF}

end.

