{ Copyright (C) 09/09/2004 00:00, Luis R. Hilario B. <info@luisdigital.com>

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Library General Public License as published by
  the Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}

unit factura;

{$IFDEF FPC}
 {$mode objfpc}
{$ENDIF}
{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs,
  {$IFDEF FPC}
  LResources, Process, LCLType, //VK_Keys (Windows o Types)
  {$ELSE}
  Windows,
  {$ENDIF}
  Grids, StdCtrls,
  klintonstrconst, Buttons, Util, TxtDB, ExtCtrls;

type
  TForm9 = class(TForm)
    BitbtnAyuda: TBITBTN;
    ButtonVer: TBUTTON;
    ButtonIns: TBUTTON;
    ButtonEli: TBUTTON;
    ButtonInv: TBUTTON;
    ButtonCerrar: TBUTTON;
    ButtonGuardar: TBUTTON;
    ButtonGI: TBUTTON;
    ComboboxCN1: TCOMBOBOX;
    ComboboxCN2: TCOMBOBOX;
    ComboboxP: TCOMBOBOX;
    ComboboxCC1: TCOMBOBOX;
    ComboboxCC2: TCOMBOBOX;
    EditC1: TEDIT;
    EditC2: TEDIT;
    EditC3: TEDIT;
    EditSub: TEDIT;
    EditDes2: TEDIT;
    EditImp2: TEDIT;
    EditDes1: TEDIT;
    EditImp1: TEDIT;
    EditOtros: TEDIT;
    EditDir11: TEDIT;
    EditPagado: TEDIT;
    EditSaldo: TEDIT;
    EditVence: TEDIT;
    EditDir12: TEDIT;
    EditDir21: TEDIT;
    EditDir22: TEDIT;
    EditEnviar: TEDIT;
    EditFecha: TEDIT;
    EditV: TEDIT;
    EditNF: TEDIT;
    Groupbox1: TGROUPBOX;
    Groupbox2: TGROUPBOX;
    Groupbox3: TGROUPBOX;
    Groupbox4: TGROUPBOX;
    Label1: TLABEL;
    Label2: TLABEL;
    LabelVence: TLABEL;
    LabelPagado: TLABEL;
    LabelSaldo: TLABEL;
    LabelDesc: TLABEL;
    LabelImp: TLABEL;
    LabelOtros: TLABEL;
    LabelSubTotal: TLABEL;
    LabelVend: TLABEL;
    LabelFecha: TLABEL;
    LabelPago: TLABEL;
    LabelEnviar: TLABEL;
    LabelNF: TLABEL;
    Panel1: TPANEL;
    StringGrid1: TStringGrid;
    StaticText1: TStaticText;
    procedure ButtonEliCLICK(Sender: TObject);
    procedure ButtonGICLICK(Sender: TObject);
    procedure ButtonGuardarCLICK(Sender: TObject);
    procedure ButtonInsCLICK(Sender: TObject);
    procedure ButtonInvCLICK(Sender: TObject);
    procedure ButtonVerCLICK(Sender: TObject);
    procedure ComboboxCC1KEYDOWN(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboboxCN1CHANGE(Sender: TObject);
    procedure ComboboxCN1EXIT(Sender: TObject);
    procedure ComboboxPKEYDOWN(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditDir21ENTER(Sender: TObject);
    procedure EditNFEXIT(Sender: TObject);
    procedure EditNFKEYPRESS(Sender: TObject; var Key: Char);
    procedure EditVenceEXIT(Sender: TObject);
    procedure EditFechaEXIT(Sender: TObject);
    procedure EditSubCHANGE(Sender: TObject);
    procedure Form9CLOSEQUERY(Sender: TObject; var CanClose: boolean);
    procedure Form9CREATE(Sender: TObject);
    procedure Form9KEYDOWN(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Form9SHOW(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure StringGrid1SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure EditOtrosChange(Sender: TObject);
    procedure EditDes1Change(Sender: TObject);
    procedure EditImp1Change(Sender: TObject);
    procedure EditPagadoChange(Sender: TObject);
    procedure BitbtnAyudaClick(Sender: TObject);
  private
    { private declarations }
    ComboboxReady: Boolean;
    TempCols: Array[0..1] of TStrings;
    procedure UpdateEditSub;
    procedure UpdateEditTotal;
    function OverLength: Boolean;
  public
    { public declarations }
  end; 

var
  Form9: TForm9;
  TXTDBClientes,
  TXTDBInventario,
  TXTDBFactura,
  TXTDBItems: TTXTDB;

implementation

uses productos, inventario, imprimir;

procedure TForm9.UpdateEditSub;
var
  R: Real;
  Fmt: String;
  Index: Integer;

begin
  R := 0;
  Fmt := '%0f';
  For Index := 1 to StringGrid1.RowCount -1 do
  begin
    R := R + StrReal(StringGrid1.Cells[4,Index]);
  end;
  EditSub.Text := Format(Fmt, [R]);
  EditSub.Text := Format(Fmt, [StrReal(EditSub.Text)+StrReal(EditOtros.Text)]);
end;

procedure TForm9.UpdateEditTotal;
var
  Total: Real;

begin
  Total:= StrReal(EditSub.Text) +StrReal(EditDes2.Text) +StrReal(EditImp2.Text);
  StaticText1.Caption := StrNumStr(NumStr(Total),0,2);

  Total := Total - StrReal(EditPagado.Text);
  EditSaldo.Text := StrNumStr(NumStr(Total),0,2);
end;

function TForm9.OverLength: Boolean;
begin
  if Length(StrNumStr(StaticText1.Caption, 0, 2)) > StaticText1.Tag then
    Result := True else Result := False
end;

{ TForm9 }

procedure TForm9.Form9CREATE(Sender: TObject);
begin
  KeyPreview:= True;
  LabelNF.Caption := rsNFactura;
  LabelFecha.Caption := rsFecha;
  LabelEnviar.Caption := rsEnviar;
  LabelPago.Caption := rsPago;
  LabelVend.Caption := rsVend;
  LabelSubTotal.Caption := rsSubTotal +':';
  LabelOtros.Caption := rsOtros;
  LabelDesc.Caption := rsDesc;
  LabelImp.Caption := rsImp;
  LabelPagado.Caption := rsPagado;
  LabelSaldo.Caption := rsSaldo;
  LabelVence.Caption := rsVence;
  Groupbox1.Caption := rsComprador;
  Groupbox2.Caption := rsEnviar_a;
  Groupbox3.Caption := rsComentario;
  Groupbox4.Caption := rsTOTAL;
  ButtonIns.Caption := rsInsertarFila;
  ButtonEli.Caption := rsEliminarFila;
  ButtonCerrar.Caption := rsACerrar;
  ButtonGuardar.Caption := rsAGuardar;
  ButtonGI.Caption := rsAGI;
  ButtonVer.Caption := rsVerProd;
  ButtonInv.Caption := rsListaProd;
  BitbtnAyuda.Caption := rsAAyuda;
end;

procedure TForm9.Form9KEYDOWN(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin
  Case Key of
   VK_F3: ButtonVerCLICK(Nil);
   VK_F4: ButtonInvCLICK(Nil);
   VK_F5: ButtonInsCLICK(Nil);
   VK_F6: ButtonEliCLICK(Nil);
  end;
end;

procedure TForm9.Form9SHOW(Sender: TObject);
var
  Index, NF: Integer;
  NoSeguir: Boolean;

begin
  With StringGrid1 do
  begin
    Options := [gofixedvertline,gofixedhorzline,
                govertline,gohorzline,gorangeselect,
                gocolsizing,goediting];
    DefaultColWidth := 110;
    DefaultRowHeight := 19;
    FixedCols := 0;
    GridLineWidth := 1;
    for Index := 0 to ColCount-1 do Cols[Index].Clear;
    RowCount := 2;
    {$IFDEF FPC}
    ScrollBars := ssAutoBoth;
    {$ELSE}
    ScrollBars := ssBoth;
    {$ENDIF}
    ColWidths[0] := 115;
    Cells[0,0] := 'Cd. Artculo';
    Cells[1,0] := 'Artculo';
    ColWidths[1] := 200;
    Cells[2,0] := 'Cant.';
    Cells[3,0] := 'Prec. Unidad';
    Cells[4,0] := rsSubTotal;
// No soportado en Delphi
    {$IFDEF FPC}
    ColAlign[2] := CA_Right;
    ColAlign[3] := CA_Right;
    ColAlign[4] := CA_Right;
    OnBEFORESELECTION := nil;
    OnSelectEditor := nil;
    {$ENDIF}
  end;

  ComboboxP.Clear;
  if MaxPagoTipo > -1 then
  begin
    for Index := 0 to MaxPagoTipo do ComboboxP.Items.Add(PagoTipo[Index]);
    ComboboxP.ItemIndex := 0;
  end;

  ComboboxReady := False;
  ComboboxCN1.Clear;
  ComboboxCC1.Clear;
  ComboboxCN2.Clear;
  ComboboxCC2.Clear;

  TXTDBClientes := TTXTDB.create(ArchivoTXTDBClientes);
  With TXTDBClientes do
  begin
  ReadTXTDB;
  for Index := 1 to RecordCount do
  begin
    RecordIndex := Index;
    if RecordData[fnCATEGORIA] = rsCliente then
    begin
      ComboboxCN1.Items.Add(RecordData[fnCODIGO]);
      ComboboxCC1.Items.Add(RecordData[fnNOMBRE]);
    end;
  end;
    Free;
  end;

  ComboboxCN2.Items := ComboboxCN1.Items;
  ComboboxCC2.Items := ComboboxCC1.Items;
  ComboboxReady := True;

  ComboboxCN1.ItemIndex := 0;
  ComboboxCN2.ItemIndex := 0;
  ComboboxCN1CHANGE(ComboboxCN1);
  ComboboxCN1CHANGE(ComboboxCN2);

  NF := 0;
  if Caption = rsNuevo then // Limpiar todo
  begin
    EditNF.Enabled := True;
    TXTDBFactura := TTXTDB.create(ArchivoTXTDBFactura);
    With TXTDBFactura do
    begin
     ReadTXTDB;
     for Index := 1 to RecordCount do
     begin
       RecordIndex := Index;
       if NF < RecordDataI[fnNRO_FACT] then NF := RecordDataI[fnNRO_FACT];
     end;
     Free;
    end;
    EditNF.Text := NumStr(NF+1);
    EditNFEXIT(nil);
    EditFecha.Text := DateToStr(Date);
    EditEnviar.Text := '';
    EditV.Text := '';
    EditDes1.Text := '';
    EditImp1.Text := '';
    EditOtros.Text := EditDes1.Text;
    EditC1.Text := '';
    EditC2.Text := '';
    EditC3.Text := '';
    EditVence.Text := DateToStr(Date);
    EditPagado.Text := EditDes1.Text;
  end;

  if Caption = rsModificar then // Leer registro
  begin
    EditNF.Enabled := False;
    With TTXTDB.create(ArchivoTXTDBFactura) do
     begin
       ReadTXTDB;
       RecordIndex := Tag;
       EditNF.Text := RecordData[fnNRO_FACT];
//Se necesita ahora el NF.. continua ms abajo...

    TXTDBItems := TTXTDB.create(ArchivoTXTDBItems);
    With TXTDBItems, StringGrid1 do
     begin
       ReadTXTDB;
       if DataExist(fnNRO_FACT, EditNF.Text) then
        begin
        Index := 1;
        repeat
        Row := Index;
        Cells[0, Index] := RecordData[fnITEM];
        Cells[1, Index] := RecordData[fnDESC];
        Cells[2, Index] := RecordData[fnCANTIDAD];
        Cells[3, Index] := RecordData[fnPRECIO];
        StringGrid1SetEditText(nil, 3, Index, Cells[3, Index]);
        RecordIndex := RecordIndex +1;
        NoSeguir := (RecordIndex > RecordCount) Or
                  (RecordData[fnNRO_FACT] <> EditNF.Text);
        if NoSeguir = False then
          begin
            ButtonInsCLICK(nil);
            Inc(Index);
          end;
        until NoSeguir;
        end;
       TXTDBItems.Free
     end;

//Continuacin de ArchivoTXTDBFactura y final
       EditFecha.Text := RecordData[fnFECHA_FACT];
       EditEnviar.Text := RecordData[fnENVIAR_POR];
       ComboboxP.ItemIndex := ComboboxP.Items.IndexOf(RecordData[fnTIPO_PAGO]);
       ComboboxCN1.ItemIndex := ComboboxCN1.Items.IndexOf //Comprador...
                                (RecordData[fnCOMPRADOR]);
       EditDir11.Text := RecordData[fnDIR1];
       EditDir12.Text := RecordData[fnDIR2];

       EditDir21.Text := RecordData[fnENVIADO_A1];
       EditDir22.Text := RecordData[fnENVIADO_A2];

       EditV.Text := RecordData[fnVENDEDOR];
       EditOtros.Text := RecordData[fnOTROS];
       EditDes1.Text := RecordData[fnDESCUENTO];
       EditImp1.Text := RecordData[fnIMPUESTO];
       EditC1.Text := RecordData[fnCOMENTA1];
       EditC2.Text := RecordData[fnCOMENTA2];
       EditC3.Text := RecordData[fnCOMENTA3];
       EditVence.Text := RecordData[fnFECHA_VENC];
       EditPagado.Text := RecordData[fnCAJA_PAGO];
       Free
    end;

    for Index := 0 to 1 do TempCols[Index] := TStringList.Create;
    TempCols[0] := StringGrid1.Cols[0];
    TempCols[1] := StringGrid1.Cols[2];

    TXTDBInventario := TTXTDB.create(ArchivoTXTDBInventario);
    With StringGrid1, TXTDBInventario do//Devolver productos al inventario
     begin
       ReadTXTDB;
       for Index := 1 to RowCount -1 do
       begin
         if DataExist(fnCODIGO, Cells[0, Index]) then
           begin
             RecordData[fnCANT_ALM]:= StrNumStr(NumStr(RecordDataR[fnCANT_ALM]+
                                        StrReal(Cells[2, Index])), 14, 2);
           end;
       end;
       WriteTXTDB;
       Free;
     end;
  end;

  EditDir21ENTER(Nil);
end;

procedure TForm9.ButtonInsCLICK(Sender: TObject);
begin
  Stringgrid1.RowCount := Stringgrid1.RowCount +1;
end;

procedure TForm9.ButtonInvCLICK(Sender: TObject);
begin
  Form6.BitbtnVer.Caption := rsAInsertar;
  if Form6.Showmodal = mrOK then begin end;

  if Form6.Tag > 0 then
  begin
    TXTDBInventario := TTXTDB.create(ArchivoTXTDBInventario);
     With TXTDBInventario, StringGrid1 do
      begin
        ReadTXTDB;
        RecordIndex := Form6.Tag;
//Existencia?
        if Not Boolean(RecordDataI[fnFACT_SIN_EX]) then
          if RecordDataR[fnCANT_ALM] <= 0 then
            begin
              MSGError(rsNoExist);
              TXTDBInventario.Free;
              Exit;
            end else
              if RecordDataR[fnCANT_ALM] <= RecordDataR[fnCANT_MINI] then
                MSGInfo(rsProMini+RecordData[fnCANT_ALM]);
//Expiro?
        if Boolean(RecordDataI[fnAVISAR_F_E]) and
           (RecordData[fnF_EXP] <> '') then
             if StrToDate(RecordData[fnF_EXP]) <= Date then
               if MSGConfirmationYN(rsExp1+RecordData[fnF_EXP]+rsExp2) <> mrYes
               then
                 begin
                  TXTDBInventario.Free;
                  Exit;
                 end;

        Cells[0, Row] := RecordData[fnCODIGO];
        Cells[1, Row] := RecordData[fnDESC];
        Cells[3, Row] := RecordData[fnPRECIO1];
        {EditExitCol2(Nil);
        EditExitCol3(Nil)}
      end;
    TXTDBInventario.Free;
  end;
end;

procedure TForm9.ButtonVerCLICK(Sender: TObject);
var
  Row: Integer;
  Codigo: String;

begin
  Row := Stringgrid1.Row;
  Codigo := Stringgrid1.Cells[0, Row];
  if (Stringgrid1.RowCount <= Row) Or (Codigo = '') then MSGInfo(rsNoSelected)
  else
  begin
    Form7.Caption := rsVer;
    TXTDBInventario := TTXTDB.create(ArchivoTXTDBInventario);
     With TXTDBInventario do
      begin
        ReadTXTDB;
        if Not DataExist(fnCODIGO, Codigo) then
         begin
          Free;
          MSGError(rsInvalidCode);
          Exit
         end;
        Form7.Tag := RecordIndex;
        Free;
      end;
    if Form7.ShowModal = mrOk then begin end;
  end;
end;

procedure TForm9.ComboboxCC1KEYDOWN(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Key := 0;
end;

procedure TForm9.ComboboxCN1CHANGE(Sender: TObject);
var
  S: String;
  Index: Integer;

begin
  if ComboboxReady then
  begin
   Index := (Sender as TCombobox).Items.IndexOf((Sender as TCombobox).Text);
   if ((Sender as TCombobox).Items.Count < 0) Or (Index < 0) then exit;

   Case (Sender as TCombobox).Tag of
    0: ComboboxCC1.ItemIndex := Index;
    1: ComboboxCN1.ItemIndex := Index;
    2: ComboboxCC2.ItemIndex := Index;
    3: ComboboxCN2.ItemIndex := Index;
   end;

  TXTDBClientes := TTXTDB.create(ArchivoTXTDBClientes);
  With TXTDBClientes do
  begin
  ReadTXTDB;
  Case (Sender as TCombobox).Tag of
    0,1: begin
          DataExist(fnCODIGO, ComboBoxCN1.Text);
          EditDir11.Text := RecordData[fnDir1];
          S := RecordData[fnCIUDAD];
          if S <> '' then EditDir11.Text := EditDir11.Text + ', ' + S;
          S := RecordData[fnESTADO];
          if S <> '' then EditDir11.Text := EditDir11.Text + ', ' + S;
          S := RecordData[fnZIP];
          if S <> '' then EditDir11.Text := EditDir11.Text + ', ' + S;
          S := RecordData[fnDir2];
          if S <> '' then S := S + ' ';
          EditDir12.Text := S + 'Tel.: ' +
                            RecordData[fnTEL]+ ' Fax: ' +
                            RecordData[fnFAX];
         end;
    2,3: begin
          DataExist(fnCODIGO, ComboBoxCN2.Text);
          EditDir21.Text := RecordData[fnDir1];
          S := RecordData[fnCIUDAD];
          if S <> '' then EditDir21.Text := EditDir21.Text + ', ' + S;
          S := RecordData[fnESTADO];
          if S <> '' then EditDir21.Text := EditDir21.Text + ', ' + S;
          S := RecordData[fnZIP];
          if S <> '' then EditDir21.Text := EditDir21.Text + ', ' + S;
          S := RecordData[fnDir2];
          if S <> '' then S := S + ' ';
          EditDir22.Text := S + 'Tel.: ' +
                            RecordData[fnTEL]+ ' Fax: ' +
                            RecordData[fnFAX];
         end;
  end;
  Free;
  end;

  end;
end;

procedure TForm9.ComboboxCN1EXIT(Sender: TObject);
begin
  if (Sender as TCombobox).ItemIndex < 0 then
  begin
    MSGError(rsInvalidCode);
    (Sender as TCombobox).ItemIndex := 0;
    ComboboxCN1CHANGE(Sender);
  end;
  EditDir21ENTER(Nil);
end;

procedure TForm9.ComboboxPKEYDOWN(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Key := 0
end;

procedure TForm9.EditDir21ENTER(Sender: TObject);
begin
  ComboboxCN2.Text := rsSelection;
  ComboboxCC2.Text := rsSelection;
end;

procedure TForm9.EditNFEXIT(Sender: TObject);
begin
  EditNF.Text := StringOfChar('0', EditNF.MaxLength - Length(EditNF.Text))
                 + EditNF.Text;
end;

procedure TForm9.EditNFKEYPRESS(Sender: TObject; var Key: Char);
begin
  if Not(Key In['0'..'9']) then Key := #0;
end;

procedure TForm9.EditVenceEXIT(Sender: TObject);
begin
  EditVence.Text := Trim(EditVence.Text);
  if EditVence.Text <> '' then
  Try
    EditVence.Text := DateToStr(StrToDate(EditVence.Text));
  Except
    On EConvertError do
    begin
      EditVence.Text := DateToStr(Date);
      MSGError(rsInvalidDate);
    end;
  end;
end;

procedure TForm9.EditFechaEXIT(Sender: TObject);
begin
  EditFecha.Text := Trim(EditFecha.Text);
  if EditFecha.Text <> '' then
  Try
    EditFecha.Text := DateToStr(StrToDate(EditFecha.Text));
  Except
    On EConvertError do
    begin
      EditFecha.Text := DateToStr(Date);
      MSGError(rsInvalidDate);
    end;
  end;
end;

procedure TForm9.EditSubCHANGE(Sender: TObject);
begin
  EditDes1Change(EditDes1);
  EditImp1Change(EditImp1);
  UpdateEditTotal;
  EditPagado.Text := StaticText1.Caption;
end;

procedure TForm9.Form9CLOSEQUERY(Sender: TObject; var CanClose: boolean);
var
  Index: Integer;

begin
  if Caption = rsModificar then
    begin
      if ModalResult <> mrOk then
        begin
          TXTDBInventario := TTXTDB.create(ArchivoTXTDBInventario);
          With TXTDBInventario do//Devolver productos al inventario
           begin
             ReadTXTDB;
             For Index := 1 to TempCols[0].Count-1 do
             begin
               if DataExist(fnCODIGO, TempCols[0][Index]) then
                 begin
                   RecordData[fnCANT_ALM] := StrNumStr(
                   NumStr(RecordDataR[fnCANT_ALM] - StrReal(
                   TempCols[1][Index])), 14, 2);
                 end;
             end;
             WriteTXTDB;
             Free;
           end;
        end;

{      For Index := 0 to 1 do TempCols[Index].Free;
       En Delphi (6) se libera automticamente, Free no es necesario y
       peor an da error al final del programa.
       En Free Pascal se debe de liberar manualmente?} 
    end;
end;

procedure TForm9.ButtonEliCLICK(Sender: TObject);
begin
  With StringGrid1 do
  begin
    Rows[RowCount -1].Clear;
    if RowCount > 2 then RowCount := RowCount -1;
  end;
  UpdateEditSub;
end;

procedure TForm9.ButtonGICLICK(Sender: TObject);
var
  X, Y: Integer;

begin
  ButtonGuardarCLICK(nil);

  if ModalResult = mrNone then Exit;

  HTMLPrint := THTMLPrint.Create(Plantillas);
  With HTMLPrint do
    begin
      Read;
      Archivo := Plantillas_Salida;

      Table_Name := ArchivoTXTDBFactura;
      Print(EditNF.Text, fnNRO_FACT);
      Print(EditFecha.Text, fnFECHA_FACT);
      Print(EditVence.Text, fnFECHA_VENC);
      Print(ComboboxCC1.Text, fnCOMPRADOR);
      Print(EditDir21.Text, fnENVIADO_A1);
      Print(EditDir22.Text, fnENVIADO_A2);
      Print(EditEnviar.Text, fnENVIAR_POR);
      Print(ComboboxP.Text, fnTIPO_PAGO);
      Print(EditV.Text, fnVENDEDOR);
      Print(EditOtros.Text, fnOTROS);
      Print(EditSub.Text, SubTotal);
      Print(EditDes2.Text, fnDESCUENTO);
      Print(EditImp2.Text, fnIMPUESTO);
      Print(StaticText1.Caption, fnTOTAL);

      Print(EditC1.Text, fnCOMENTA1);
      Print(EditC2.Text, fnCOMENTA2);
      Print(EditC3.Text, fnCOMENTA3);

      Print(EditPagado.Text, fnCAJA_PAGO);
      Print(EditSaldo.Text, cSaldo);

      Table_Name := ArchivoTXTDBItems;
      AddRow(Stringgrid1.RowCount-2);
      for Y := 1 to Stringgrid1.RowCount-1 do
        for X := 0 to Stringgrid1.ColCount-1 do
          Case X of
           0: TablePrint(Stringgrid1.Cells[X, Y], fnITEM, Y);
           1: TablePrint(Stringgrid1.Cells[X, Y], fnDESC, Y);
           2: TablePrint(Stringgrid1.Cells[X, Y], fnCANTIDAD, Y);
           3: TablePrint(Stringgrid1.Cells[X, Y], fnPRECIO, Y);
           4: TablePrint(Stringgrid1.Cells[X, Y], SubTotal, Y);
          end;

      With TTXTDB.create(ArchivoTXTDBConf) do
      begin
       Table_Name := Archivo;
       ReadTXTDB;
       if Boolean(RecordDataI[fnPNOMBRE]) then
         Print(RecordData[fnNOMBRE], fnNOMBRE);
       if Boolean(RecordDataI[fnPSLOGAN]) then
         Print(RecordData[fnSLOGAN], fnSLOGAN);
       if Boolean(RecordDataI[fnPDIR1]) then
         Print(RecordData[fnDIR1], fnDIR1);
       if Boolean(RecordDataI[fnPCIUDAD]) then
         Print(RecordData[fnCIUDAD], fnCIUDAD);
       if Boolean(RecordDataI[fnPTEL]) then
         Print(RecordData[fnTEL], fnTEL);
       if Boolean(RecordDataI[fnPEMAIL]) then
         Print(RecordData[fnEMAIL], fnEMAIL);

       HTMLPrint.Write;

       if RecordData[fnNAVEGADOR] = cPredeterminado then
         ExecuteFile(GetCurrentDir+ '\'+HTMLPrint.Archivo, '')
       else
         ExecuteFile(RecordData[fnNAVEGADOR],
                     GetCurrentDir+ '\'+HTMLPrint.Archivo);
   
       Free;
      end;
      Free;
    end;
  ProgramReset;
end;

procedure TForm9.ButtonGuardarCLICK(Sender: TObject);
var
  Index: Integer;

begin
  if OverLength then
  begin
    MSGError('Total demasiado grande...');
    ModalResult := mrNone;
    Exit
  end;

  TXTDBInventario := TTXTDB.create(ArchivoTXTDBInventario);
  With StringGrid1, TXTDBInventario do
   begin//Verificar producto vendido No > Inventario
     ReadTXTDB;
     for Index := 1 to RowCount -1 do
     begin
       if DataExist(fnCODIGO, Cells[0, Index]) then
         begin
           RecordData[fnCANT_ALM] := StrNumStr(NumStr(RecordDataR[fnCANT_ALM] -
                                      StrReal(Cells[2, Index])), 14, 2);
           if Not Boolean(RecordDataI[fnFACT_SIN_EX]) then
             if RecordDataR[fnCANT_ALM] < 0 then
               begin
                 MSGError(rsNoExist+#10+
                          rsCode+Cells[0, Row]+#10+
                          rsTOTAL+ ' ' +RecordData[fnCANT_ALM]);
                 Free;
                 ModalResult := mrNone;
                 Exit;
               end;
         end;
     end; // for Index
     Free;
   end;

  TXTDBFactura := TTXTDB.create(ArchivoTXTDBFactura);
  With TXTDBFactura do
   begin
     ReadTXTDB;

     if Caption = rsNuevo then
     begin
       if DataExist(fnNRO_FACT, EditNF.Text) then
       begin
         MSGInfo('Nmero de Factura ya existe.');
         Free;
         ModalResult := mrNone;
         Exit
       end;
       RecordAdd;
       RecordData[fnNRO_FACT] := EditNF.Text
     end else RecordIndex := Tag;

     RecordData[fnFECHA_FACT] := EditFecha.Text;
     RecordData[fnENVIAR_POR] := EditEnviar.Text;
     RecordData[fnTIPO_PAGO] := ComboboxP.Text;
     RecordData[fnCOMPRADOR] := ComboboxCN1.Text;
     RecordData[fnDIR1] := EditDir11.Text;
     RecordData[fnDIR2] := EditDir12.Text;

     RecordData[fnENVIADO_A1] := EditDir21.Text;
     RecordData[fnENVIADO_A2] := EditDir22.Text;

     RecordData[fnVENDEDOR] := EditV.Text;
     RecordData[fnOTROS] := EditOtros.Text;
     RecordData[fnDESCUENTO] := EditDes1.Text;
     RecordData[fnIMPUESTO] := EditImp1.Text;
     RecordData[fnCOMENTA1] := EditC1.Text;
     RecordData[fnCOMENTA2] := EditC2.Text;
     RecordData[fnCOMENTA3] := EditC3.Text;
     RecordData[fnFECHA_VENC] := EditVence.Text;
     RecordData[fnTOTAL] := StaticText1.Caption;
     RecordData[fnCAJA_PAGO] := EditPagado.Text;
     WriteTXTDB;
     Free;
   end;

  TXTDBInventario := TTXTDB.create(ArchivoTXTDBInventario);
  TXTDBInventario.ReadTXTDB;

  TXTDBItems := TTXTDB.create(ArchivoTXTDBItems);
  With StringGrid1, TXTDBItems do
   begin
     ReadTXTDB;
     if DataExist(fnNRO_FACT, EditNF.Text) then
      repeat
       if Not RecordDelete then MSGError(rsNoDeleted);
      until  (RecordIndex > RecordCount) Or
             (RecordData[fnNRO_FACT] <> EditNF.Text);
//Escribir los ITEMS
     for Index := 1 to RowCount -1 do
     begin
      RecordAdd;
      RecordData[fnNRO_FACT] := EditNF.Text;
      RecordData[fnITEM] := Cells[0, Index];
      if TXTDBInventario.DataExist(fnCODIGO, Cells[0, Index]) then
        RecordData[fnCOSTO] := TXTDBInventario.RecordData[fnCOSTO];
      RecordData[fnDESC] := Cells[1, Index];
      RecordData[fnCANTIDAD] := Cells[2, Index];
      RecordData[fnPRECIO] := Cells[3, Index];
     end;
     WriteTXTDB;
     Free;
   end;

  With StringGrid1, TXTDBInventario do//Sacar del inventario producto vendido
   begin
     for Index := 1 to RowCount -1 do
     begin
       if DataExist(fnCODIGO, Cells[0, Index]) then
         begin
           RecordData[fnCANT_ALM] := StrNumStr(NumStr(RecordDataR[fnCANT_ALM] -
                                      StrReal(Cells[2, Index])), 14, 2);
           if (RecordData[fnF_EXP] = '') Or
             (StrToDate(RecordData[fnULT_VEN]) < StrToDate(EditFecha.Text)) then
            RecordData[fnULT_VEN] := EditFecha.Text;
         end;
     end;
     WriteTXTDB;
     Free;
   end;

end;

procedure TForm9.StringGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  if ACol In[0,4] then CanSelect := False else
   if (ACol = 3) and (Stringgrid1.Cells[0, ARow] = '') then CanSelect := False
end;

procedure TForm9.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var Texto:String;
    i:integer;

begin
  if (StringGrid1.Cells[ACol,ARow] <> '') and
     (ARow <> 0) and (ACol in [2..4]) then
  begin
      Texto := Format('%17.2f',[StrToFloat(StringGrid1.Cells[ACol,ARow])]);
      with StringGrid1 do
        with Canvas,Rect do
        begin
          i:=Right-TextWidth(Texto+' ');
          canvas.Brush.Color := Color;
          canvas.pen.color := Color;
          Canvas.FillRect(Rect);
          if gdSelected in State then Canvas.Font.Color := Not Color;
          Canvas.TextOut(i, Top+2, Texto);
        end;
  end;
end;

procedure TForm9.StringGrid1SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var
  I: Integer;
  R: Real;
  Resultado, Texto: String;

begin
  if ACol in[2,3] then
  begin
  Texto := Value;
  if ACol = 2 then I := 14 else I := 15;
  Resultado := ValidateFormat(Texto, I, 2);

  if Resultado <> '' then
  begin
   MSGError(Resultado);
   StringGrid1.Cells[ACol, ARow] := Texto;
  end;

  R := StrReal(StringGrid1.Cells[2, ARow]) *
       StrReal(StringGrid1.Cells[3, ARow]);

  StringGrid1.Cells[4, ARow] :=  Format('%20.2f', [R]);
  UpdateEditSub;
  end;
end;

procedure TForm9.EditOtrosChange(Sender: TObject);
begin
  ValidateText(Sender);
  UpdateEditSub;
end;

procedure TForm9.EditDes1Change(Sender: TObject);
begin
  ValidateText(Sender);
  EditDes2.Text := StrNumStr(
    NumStr(-StrReal(EditSub.Text) * (StrReal(EditDes1.Text)/100)), 0,2);
end;

procedure TForm9.EditImp1Change(Sender: TObject);
begin
  ValidateText(Sender);
  EditImp2.Text := StrNumStr(
    NumStr(StrReal(EditSub.Text) * (StrReal(EditImp1.Text)/100)), 0,2);
end;

procedure TForm9.EditPagadoChange(Sender: TObject);
begin
  ValidateText(Sender);
  UpdateEditTotal;
end;

procedure TForm9.BitbtnAyudaClick(Sender: TObject);
begin
  AyudaHTML(Con_CrearF);
end;

initialization
{$IFDEF FPC}
  {$I factura.lrs}
{$ELSE}
  {$R *.dfm}
{$ENDIF}

end.
//Fecha Ultima Venta del producto, si la factura es modificada?
// :-) MONICA LO USA ASI TAMBIEN JEJE
