{ Copyright (C) 09/09/2004 00:00, Luis R. Hilario B. <info@luisdigital.com>

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Library General Public License as published by
  the Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}

unit inventario;

{$IFDEF FPC}
 {$mode objfpc}
{$ENDIF}
{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs,
  {$IFDEF FPC}LResources,{$ENDIF} ExtCtrls,
  Buttons, ComCtrls,
  util, klintonstrconst, TXTDB, StdCtrls, ImgList;

type
  TForm6 = class(TForm)
    Bitbtn1: TBITBTN;
    Shape1: TSHAPE;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Listview1: TListView;
    BitbtnNuevo: TBitBtn;
    BitbtnModificar: TBitBtn;
    BitbtnVer: TBitBtn;
    BitbtnEliminar: TBitBtn;
    BitbtnAyuda: TBitBtn;
    ImageList1: TImageList;
    procedure BitbtnEliminarCLICK(Sender: TObject);
    procedure BitbtnModificarCLICK(Sender: TObject);
    procedure BitbtnNuevoCLICK(Sender: TObject);
    procedure BitbtnVerCLICK(Sender: TObject);
    procedure Form6CREATE(Sender: TObject);
    procedure Form6SHOW(Sender: TObject);
    procedure BitbtnAyudaClick(Sender: TObject);
  private
    { private declarations }
    procedure UpdateListView1;
  public
    { public declarations }
  end; 

var
  Form6: TForm6; 
  TXTDBInventario: TTXTDB;

implementation

uses productos;

{ TForm6 }

procedure TForm6.Form6CREATE(Sender: TObject);
begin
  BitbtnNuevo.Caption := rsANuevo;
  BitbtnModificar.Caption := rsAModificar;
  BitbtnEliminar.Caption := rsAEliminar;
  BitbtnAyuda.Caption := rsAAyuda;
  Bitbtn1.Caption := rsACerrar;
end;

procedure TForm6.BitbtnEliminarCLICK(Sender: TObject);
var
  RecordDeleted: Boolean;

begin
  if ListView1.Selected = nil then MSGInfo(rsNoSelected)
  else
    if MSGConfirmationYN(rsDeleteReg) = mrYes then
    begin
      TXTDBInventario := TTXTDB.create(ArchivoTXTDBInventario);
      TXTDBInventario.ReadTXTDB;
      TXTDBInventario.RecordIndex := ListView1.Selected.Index +1;
      RecordDeleted := TXTDBInventario.RecordDelete;
      TXTDBInventario.Free;
      if RecordDeleted then UpdateListView1 else MSGError(rsNoDeleted);
    end;
end;

procedure TForm6.BitbtnModificarCLICK(Sender: TObject);
begin
  if ListView1.Selected = nil then MSGInfo(rsNoSelected)
  else
  begin
    Form7.Caption := rsModificar;
    Form7.Tag := ListView1.Selected.Index +1;
    if Form7.ShowModal = mrOk then UpdateListView1;
  end;
end;

procedure TForm6.BitbtnNuevoCLICK(Sender: TObject);
begin
  Form7.Caption := rsNuevo;
  if Form7.ShowModal = mrOk then UpdateListView1;
end;

procedure TForm6.BitbtnVerCLICK(Sender: TObject);
begin
  if ListView1.Selected = nil then MSGInfo(rsNoSelected)
  else
  begin
    Tag := ListView1.Selected.Index +1;
    if BitbtnVer.Caption = rsAVer then
      begin
       Form7.Caption := rsVer;
       Form7.Tag := Tag;
       if Form7.ShowModal = mrOk then begin end;
      end
    else
    Close;
  end;
end;

procedure TForm6.Form6SHOW(Sender: TObject);
begin
  Tag := 0;
  BitbtnVer.Glyph := nil;
  if BitbtnVer.Caption = rsAVer then
    ImageList1.GetBitmap(1, BitbtnVer.Glyph)
//CargarRecImag('ojos')
  else
    ImageList1.GetBitmap(0, BitbtnVer.Glyph);
//CargarRecImag('fact');
  UpdateListView1;
end;

procedure TForm6.UpdateListView1;
var
  Index: Integer;
  Iteme: TListItem;

begin
  TXTDBInventario := TTXTDB.create(ArchivoTXTDBInventario);
  With TXTDBInventario do
  begin
   ReadTXTDB;
   Listview1.Items.Clear;
   for Index := 1 to RecordCount do
   begin
     Iteme := Listview1.Items.Add;
     RecordIndex := Index;
     Iteme.Caption := RecordData[fnCODIGO];
     Iteme.SubItems.Add(RecordData[fnDESC]);
     Iteme.SubItems.Add(ProdTipo[RecordDataI[fnPROD_TIPO]]);
     Iteme.SubItems.Add(RecordData[fnCANT_ALM]);
     Iteme.SubItems.Add(RecordData[fnPRECIO1]);
     Iteme.SubItems.Add(RecordData[fnPRECIO2]);
     Iteme.SubItems.Add(RecordData[fnULT_VEN]);
   end;
   Free;
  end;
end;

procedure TForm6.BitbtnAyudaClick(Sender: TObject);
begin
  AyudaHTML(Con_Opc);
end;

initialization
{$IFDEF FPC}
  { $I inventario.lrs}
  {$I pics/botones.lrs}
{$ELSE}
  {$R *.dfm}
{$ENDIF}
end.

